/*
	$Id: heap.h,v 1.1 2001/05/07 20:15:01 syl Exp $

	Copyright (C) 1999, 2000, 2001 Syllabub
	Maroontress Fast Software.
*/

#define HEAP_ERROR -1
#define HEAP_SUCCESS 0

typedef struct HeapCell *HeapCell;

typedef struct HeapNode {
    struct HeapNode *next;   /* ꥹȡּ */
    struct HeapNode *prev;   /* ꥹȡ */
    struct HeapNode *parent; /* ĥ꡼ֿơ */
    struct HeapNode *left;   /* ĥ꡼ֺλҡ */
    struct HeapNode *right;  /* ĥ꡼ֱλҡ */
    HeapCell value;
} HeapNode;

typedef struct Heap {
    HeapNode *root;  /* 롼 */
    HeapNode *last;  /* ǸΥΡ (LN) */
    int n_nodes;     /* ҡפ˴ޤޤΡɤο */
    int (*compare)(HeapCell, HeapCell);
} Heap;

Heap * CreateHeap(int (*)(HeapCell, HeapCell));
int InsertIntoHeap(Heap *h, HeapCell c);
HeapCell TakeMinOfHeap(Heap *h);
#define NodesOfHeap(h) ((h)->n_nodes)
void FreeHeap(Heap *h);

/*
  Heap * CreateHeap(compare):
  int compare(HeapCell, HeapCell);

  ؿCreateHeap()ϥҡפбHeap¤Τ֤
  compareˤϥҡפ˴ޤޤΡɤ羮Ӥؿꤹ롣

  Heap¤ΤǤʤȤNULL֤
  Heap¤ΤפˤʤäϴؿFreeHeap()ǲ롣
*/

/*
  int InsertIntoHeap(heap, cell):
  Heap *heap;
  HeapCell *cell;

  ؿInsertIntoHeap()ϥҡפ˥ä롣
  heapоݤȤʤҡפбHeap¤ΤΥݥ󥿤ꤹ롣
  cellϲä륻Υݥ󥿤ꤹ롣μΤϥԡʤΤǡ
  cellϾʤƤҡפФޤǤδͭǤʤФʤʤ

  ץꥱϥμΤǤHeapCell¤Τɬפ롣

  ؿInsertIntoHeap()HEAP_SUCCESS
  ԤHEAP_ERROR֤
  HEAP_ERRORϥɲüԤ̣ƤʤΤǡξǤ
  оݤΥҡפľξ֤Ѥ餺ͭʤޤޤǤ롣
*/

/*
  HeapCell TakeMinOfHeap(heap):
  Heap *heap;

  ؿTakeMinOfHeap()ϥҡפǾƬˤΥФ֤
  heapоݤȤʤҡפбHeap¤ΤΥݥ󥿤ꤹ롣
  
  ֤줿ϤǤ˥ҡפ˴ޤޤƤʤ
  δؿǥҡפФϡΥμΤƤ褤

  ҡפξNULL֤롣
*/

/*
  void FreeHeap(heap):
  Heap *heap;

  ؿFreeHeap()ϥҡפ롣
  heapоݤȤʤҡפбHeap¤ΤΥݥ󥿤ꤹ롣

  ҡפ˴ޤޤ륻ϲʤ
*/
